source: postlfs/security/polkit.xml@ f13e902

10.0 10.1 11.0 9.1 ken/refactor-virt lazarus qt5new trunk upgradedb xry111/git-date xry111/git-date-for-trunk xry111/git-date-test
Last change on this file since f13e902 was f13e902, checked in by Xi Ruoyao <xry111@…>, 2 years ago

n-m-a: dep on polkit-agent instead of polkit-gnome

Other agents work as well.

git-svn-id: svn://svn.linuxfromscratch.org/BLFS/trunk/BOOK@22708 af4574ff-66df-0310-9fd7-8a98e5e911e0

  • Property mode set to 100644
File size: 13.7 KB
Line 
1<?xml version="1.0" encoding="ISO-8859-1"?>
2<!DOCTYPE sect1 PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
3 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
4 <!ENTITY % general-entities SYSTEM "../../general.ent">
5 %general-entities;
6
7 <!ENTITY polkit-download-http
8 "https://www.freedesktop.org/software/polkit/releases/polkit-&polkit-version;.tar.gz">
9 <!ENTITY polkit-download-ftp " ">
10 <!ENTITY polkit-md5sum "4b37258583393e83069a0e2e89c0162a">
11 <!ENTITY polkit-size "1.5 MB">
12 <!ENTITY polkit-buildsize "15 MB (with tests)">
13 <!ENTITY polkit-time "0.4 SBU (with tests)">
14]>
15
16<sect1 id="polkit" xreflabel="Polkit-&polkit-version;">
17 <?dbhtml filename="polkit.html"?>
18
19 <sect1info>
20 <othername>$LastChangedBy$</othername>
21 <date>$Date$</date>
22 </sect1info>
23
24 <title>Polkit-&polkit-version;</title>
25
26 <indexterm zone="polkit">
27 <primary sortas="a-Polkit">Polkit</primary>
28 </indexterm>
29
30 <sect2 role="package">
31 <title>Introduction to Polkit</title>
32
33 <para>
34 <application>Polkit</application> is a toolkit for defining and handling
35 authorizations. It is used for allowing unprivileged processes to
36 communicate with privileged processes.
37 </para>
38
39 &lfs90_checked;
40
41 <bridgehead renderas="sect3">Package Information</bridgehead>
42 <itemizedlist spacing="compact">
43 <listitem>
44 <para>
45 Download (HTTP): <ulink url="&polkit-download-http;"/>
46 </para>
47 </listitem>
48 <listitem>
49 <para>
50 Download (FTP): <ulink url="&polkit-download-ftp;"/>
51 </para>
52 </listitem>
53 <listitem>
54 <para>
55 Download MD5 sum: &polkit-md5sum;
56 </para>
57 </listitem>
58 <listitem>
59 <para>
60 Download size: &polkit-size;
61 </para>
62 </listitem>
63 <listitem>
64 <para>
65 Estimated disk space required: &polkit-buildsize;
66 </para>
67 </listitem>
68 <listitem>
69 <para>
70 Estimated build time: &polkit-time;
71 </para>
72 </listitem>
73 </itemizedlist>
74
75 <bridgehead renderas="sect3" revision="sysv">Additional Downloads</bridgehead>
76 <itemizedlist spacing="compact" revision="sysv">
77 <listitem>
78 <para>
79 Recommended patch:
80 <ulink url="&patch-root;/polkit-&polkit-version;-fix_elogind_detection-1.patch"/>
81 </para>
82 </listitem>
83 </itemizedlist>
84
85 <bridgehead renderas="sect3">Polkit Dependencies</bridgehead>
86
87 <bridgehead renderas="sect4">Required</bridgehead>
88 <para role="required">
89 <xref linkend="glib2"/> and
90 <xref linkend="js60"/>
91 </para>
92
93 <bridgehead renderas="sect4">Recommended</bridgehead>
94 <para role="recommended">
95 <xref linkend="linux-pam"/><phrase revision="sysv"> and
96 <xref linkend="elogind"/></phrase>
97 </para>
98
99 <note>
100 <para>
101 Since <phrase revision="sysv"><command>elogind</command></phrase>
102 <phrase revision="systemd"><command>systemd-logind</command></phrase>
103 uses PAM to register user sessions, it is a good idea to build
104 <application>Polkit</application> with PAM support so
105 <phrase revision="sysv"><command>elogind</command></phrase>
106 <phrase revision="systemd"><command>systemd-logind</command></phrase>
107 can track <application>Polkit</application> sessions.
108 </para>
109 </note>
110
111
112 <bridgehead renderas="sect4">Optional (Required if building GNOME)</bridgehead>
113 <para role="optional">
114 <xref linkend="gobject-introspection"/>
115 </para>
116
117 <bridgehead renderas="sect4">Optional</bridgehead>
118 <para role="optional">
119 <xref linkend="DocBook"/>,
120 <xref linkend="docbook-xsl"/>,
121 <xref linkend="gtk-doc"/>, and
122 <xref linkend="libxslt"/>
123 </para>
124
125 <bridgehead renderas="sect4" revision="systemd">Required Runtime Dependencies</bridgehead>
126 <para role="required" revision="systemd">
127 <xref role="runtime" linkend="systemd"/>
128 </para>
129
130 <bridgehead renderas="sect4" id="polkit-agent" xreflabel="Polkit Authentication Agent">
131 Optional Runtime Dependencies
132 </bridgehead>
133 <para role="optional">
134 One polkit authentication agent for using polkit in the graphical
135 environment:
136 <application>polkit-kde-agent</application> in
137 <xref role="runtime" linkend="plasma5-build"/> for KDE,
138 the agent built in
139 <xref role="runtime" linkend="gnome-shell"/> for GNOME3,
140 <xref role="runtime" linkend="polkit-gnome"/> for XFCE, and
141 <application>lxpolkit</application> in
142 <xref role="runtime" linkend="lxsession"/> for LXDE.
143 </para>
144
145 <note>
146 <para>
147 If <xref linkend="libxslt"/> is installed,
148 then <xref linkend="DocBook"/> and <xref linkend="docbook-xsl"/> are
149 required. If you have installed <xref linkend="libxslt"/>, but you do
150 not want to install any of the DocBook packages mentioned, you will
151 need to use <option>--disable-man-pages</option> in the instructions
152 below.
153 </para>
154 </note>
155
156 <para condition="html" role="usernotes">User Notes:
157 <ulink url="&blfs-wiki;/polkit"/>
158 </para>
159 </sect2>
160
161 <sect2 role="installation">
162 <title>Installation of Polkit</title>
163
164 <para>
165 There should be a dedicated user and group to take control
166 of the <command>polkitd</command> daemon after it is
167 started. Issue the following commands as the
168 <systemitem class="username">root</systemitem> user:
169 </para>
170
171<screen role="root"><userinput>groupadd -fg 27 polkitd &amp;&amp;
172useradd -c "PolicyKit Daemon Owner" -d /etc/polkit-1 -u 27 \
173 -g polkitd -s /bin/false polkitd</userinput></screen>
174
175 <note revision="systemd">
176 <para>
177 When building <application>Polkit</application> with
178 <application>systemd</application> logind support, the
179 <command>configure</command> script explicitly checks if
180 system is booted using <application>systemd</application>.
181 This can cause problems if building the package in chroot,
182 where the <command>configure</command> would fail to
183 detect <application>systemd</application>. To workaround
184 the problem, simply run the following command:
185 </para>
186
187<screen><userinput>sed -i "s:/sys/fs/cgroup/systemd/:/sys:g" configure</userinput></screen>
188 </note>
189
190 <para revision="sysv">
191 Fix an issue introduced in recent <application>Polkit</application>
192 realeases with elogind:
193 </para>
194
195<screen revision="sysv"><userinput>patch -Np1 -i ../polkit-&polkit-version;-fix_elogind_detection-1.patch &amp;&amp;
196autoreconf -fi</userinput></screen>
197 <para>
198 Install <application>Polkit</application> by running the following
199 commands:
200 </para>
201
202<screen revision="systemd"><userinput>./configure --prefix=/usr \
203 --sysconfdir=/etc \
204 --localstatedir=/var \
205 --disable-static \
206 --with-os-type=LFS &amp;&amp;
207make</userinput></screen>
208
209<screen revision="sysv"><userinput>./configure --prefix=/usr \
210 --sysconfdir=/etc \
211 --localstatedir=/var \
212 --disable-static \
213 --with-os-type=LFS \
214 --enable-libsystemd-login=no &amp;&amp;
215make</userinput></screen>
216
217 <para>
218 To test the results, issue: <command>make check</command>.
219 Note that system <application>D-Bus</application> daemon
220 must be running for the testsuite to complete.
221 </para>
222
223 <para>
224 Now, as the <systemitem class="username">root</systemitem> user:
225 </para>
226
227<screen role="root"><userinput>make install</userinput></screen>
228
229 </sect2>
230
231 <sect2 role="commands">
232 <title>Command Explanations</title>
233
234 <para>
235 <option>--with-authfw=shadow</option>: This switch enables the
236 package to use the <application>Shadow</application> rather than the
237 <application>Linux PAM</application> Authentication framework. Use it
238 if you have not installed <application>Linux PAM</application>.
239 </para>
240
241 <xi:include xmlns:xi="http://www.w3.org/2001/XInclude"
242 href="../../xincludes/static-libraries.xml"/>
243
244 <xi:include xmlns:xi="http://www.w3.org/2001/XInclude"
245 href="../../xincludes/gtk-doc-rebuild.xml"/>
246
247 <para revision="sysv">
248 <parameter>--enable-libsystemd-login=no</parameter>: This switch forces
249 polkit to build with elogind support (if available) rather than systemd.
250 </para>
251
252 </sect2>
253
254 <sect2 role="configuration">
255 <title>Configuring Polkit</title>
256
257 <sect3>
258 <title>PAM Configuration</title>
259
260 <note>
261 <para>
262 If you did not build <application>Polkit</application> with
263 <application>Linux PAM</application> support, you can skip this section.
264 </para>
265 </note>
266
267 <para>
268 If you have built <application>Polkit</application> with
269 <application>Linux PAM</application> support, you need to modify
270 the default PAM configuration file which was installed by default to get
271 <application>Polkit</application> to work correctly with BLFS. Issue the
272 following commands as the <systemitem class="username">root</systemitem>
273 user to create the configuration file for <application>Linux PAM</application>:
274 </para>
275
276<screen role="root"><userinput>cat &gt; /etc/pam.d/polkit-1 &lt;&lt; "EOF"
277<literal># Begin /etc/pam.d/polkit-1
278
279auth include system-auth
280account include system-account
281password include system-password
282session include system-session
283
284# End /etc/pam.d/polkit-1</literal>
285EOF</userinput></screen>
286
287 </sect3>
288
289 </sect2>
290
291 <sect2 role="content">
292 <title>Contents</title>
293
294 <segmentedlist>
295 <segtitle>Installed Programs</segtitle>
296 <segtitle>Installed Libraries</segtitle>
297 <segtitle>Installed Directories</segtitle>
298
299 <seglistitem>
300 <seg>
301 pkaction, pkcheck, pk-example-frobnicate, pkexec,
302 pkttyagent and polkitd
303 </seg>
304 <seg>
305 libpolkit-agent-1.so and
306 libpolkit-gobject-1.so
307 </seg>
308 <seg>
309 /etc/polkit-1,
310 /usr/include/polkit-1,
311 /usr/lib/polkit-1,
312 /usr/share/gtk-doc/html/polkit-1 and
313 /usr/share/polkit-1
314 </seg>
315 </seglistitem>
316 </segmentedlist>
317
318 <variablelist>
319 <bridgehead renderas="sect3">Short Descriptions</bridgehead>
320 <?dbfo list-presentation="list"?>
321 <?dbhtml list-presentation="table"?>
322
323 <varlistentry id="pkaction">
324 <term><command>pkaction</command></term>
325 <listitem>
326 <para>
327 is used to obtain information about registered PolicyKit actions.
328 </para>
329 <indexterm zone="polkit pkaction">
330 <primary sortas="b-pkaction">pkaction</primary>
331 </indexterm>
332 </listitem>
333 </varlistentry>
334
335 <varlistentry id="pkcheck">
336 <term><command>pkcheck</command></term>
337 <listitem>
338 <para>
339 is used to check whether a process is authorized for action.
340 </para>
341 <indexterm zone="polkit pkcheck">
342 <primary sortas="b-pkcheck">pkcheck</primary>
343 </indexterm>
344 </listitem>
345 </varlistentry>
346
347 <varlistentry id="pk-example-frobnicate">
348 <term><command>pk-example-frobnicate</command></term>
349 <listitem>
350 <para>
351 is an example program to test the <command>pkexec</command>
352 command.
353 </para>
354 <indexterm zone="polkit pk-example-frobnicate">
355 <primary sortas="b-pk-example-frobnicate">pk-example-frobnicate</primary>
356 </indexterm>
357 </listitem>
358 </varlistentry>
359
360 <varlistentry id="pkexec">
361 <term><command>pkexec</command></term>
362 <listitem>
363 <para>
364 allows an authorized user to execute a command as another user.
365 </para>
366 <indexterm zone="polkit pkexec">
367 <primary sortas="b-pkexec">pkexec</primary>
368 </indexterm>
369 </listitem>
370 </varlistentry>
371
372 <varlistentry id="pkttyagent">
373 <term><command>pkttyagent</command></term>
374 <listitem>
375 <para>
376 is used to start a textual authentication agent for the subject.
377 </para>
378 <indexterm zone="polkit pkttyagent">
379 <primary sortas="b-pkttyagent">pkttyagent</primary>
380 </indexterm>
381 </listitem>
382 </varlistentry>
383
384 <varlistentry id="polkitd">
385 <term><command>polkitd</command></term>
386 <listitem>
387 <para>
388 provides the org.freedesktop.PolicyKit1 <application>D-Bus</application>
389 service on the system message bus.
390 </para>
391 <indexterm zone="polkit polkitd">
392 <primary sortas="b-polkitd">polkitd</primary>
393 </indexterm>
394 </listitem>
395 </varlistentry>
396
397 <varlistentry id="libpolkit-agent-1">
398 <term><filename class='libraryfile'>libpolkit-agent-1.so</filename></term>
399 <listitem>
400 <para>
401 contains the <application>Polkit</application> authentication
402 agent API functions.
403 </para>
404 <indexterm zone="polkit libpolkit-agent-1">
405 <primary sortas="c-libpolkit-agent-1">libpolkit-agent-1.so</primary>
406 </indexterm>
407 </listitem>
408 </varlistentry>
409
410 <varlistentry id="libpolkit-gobject-1">
411 <term><filename class='libraryfile'>libpolkit-gobject-1.so</filename></term>
412 <listitem>
413 <para>
414 contains the <application>Polkit</application> authorization API functions.
415 </para>
416 <indexterm zone="polkit libpolkit-gobject-1">
417 <primary sortas="c-libpolkit-gobject-1">libpolkit-gobject-1.so</primary>
418 </indexterm>
419 </listitem>
420 </varlistentry>
421
422 </variablelist>
423
424 </sect2>
425
426</sect1>
Note: See TracBrowser for help on using the repository browser.